#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x24TN1x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   #define Nb N
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 24;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0;
   register float m0;
   register float rC0_0;
   do /* N-loop */
   {
      do /* M-loop */
      {
         ATL_pfl1R(pfA);
         pfA += incPFA;
         rA0 = beta;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
/*
 *       Start pipeline
 */
         rA0 = *pA0;
         rB0 = *pB0;
         m0 = rA0 * rB0;
         rA0 = pA0[1];
         rB0 = pB0[1];

         pA0 += (incAk0);
         pB0 += (incBk0);
         for (k=22; k; k--) /* easy loop to unroll */
         {
            rC0_0 += m0;
            m0 = rA0 * rB0;
            rA0 = pA0[1];
            rB0 = pB0[1];
            pA0 += incAk;
            pB0 += incBk;
         } /* end K-loop */
/*
 *       Drain pipe on last iteration of K-loop
 */
         rC0_0 += m0;
         m0 = rA0 * rB0;
         rC0_0 += m0;
         pA0 += incAk0;
         pB0 += incBk0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_cJIK0x0x24TN4x1x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=4, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   #define Nb N
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*1)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 72, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 24;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 8
   const int incCn = (((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C;
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0;
   register float m0;
   register float rC0_0, rC1_0, rC2_0, rC3_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[2];
            rC1_0 *= rA0;
            rC2_0 = pC0[4];
            rC2_0 *= rA0;
            rC3_0 = pC0[6];
            rC3_0 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rA1 = pA0[24];
            m0 = rA0 * rB0;
            rA2 = pA0[48];

            for (k=23; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rA3 = pA0[72];
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rA1 = pA0[25];
               rA2 = pA0[49];
               rC3_0 += m0;
               m0 = rA0 * rB0;
               rA3 = pA0[73];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA1 * rB0;
            rC1_0 += m0;
            m0 = rA2 * rB0;
            rC2_0 += m0;
            m0 = rA3 * rB0;
            rC3_0 += m0;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            pC0[2] = rC1_0;
            pC0[4] = rC2_0;
            pC0[6] = rC3_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_cJIK0x0x24TN1x1x1_a1_bX(k, N, 24, alpha, ca + (((Mb) << 4)+((Mb) << 3)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_cJIK0x0x24TN1x5x1_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=1, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   #define Mb M
   const int Nb = (N/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*1*5)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 0, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 120;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 2
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0;
   register float rB0, rB1, rB2, rB3, rB4;
   register float m0;
   register float rC0_0, rC0_1, rC0_2, rC0_3, rC0_4;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         do /* M-loop */
         {
            ATL_pfl1R(pfA);
            pfA += incPFA;
            rA0 = beta;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
/*
 *          Start pipeline
 */
            rA0 = *pA0;
            rB0 = *pB0;
            rB1 = pB0[24];
            m0 = rA0 * rB0;
            rB2 = pB0[48];

            for (k=23; k; k--) /* easy loop to unroll */
            {
               rC0_0 += m0;
               m0 = rA0 * rB1;
               rB3 = pB0[72];
               rC0_1 += m0;
               m0 = rA0 * rB2;
               rB4 = pB0[96];
               rC0_2 += m0;
               m0 = rA0 * rB3;
               rC0_3 += m0;
               m0 = rA0 * rB4;
               rA0 = pA0[1];
               rB0 = pB0[1];
               rB1 = pB0[25];
               rB2 = pB0[49];
               rC0_4 += m0;
               m0 = rA0 * rB0;
               rB3 = pB0[73];
               pA0 += incAk;
               pB0 += incBk;
            } /* end K-loop */
/*
 *          Drain pipe on last iteration of K-loop
 */
            rC0_0 += m0;
            m0 = rA0 * rB1;
            rB4 = pB0[96];
            rC0_1 += m0;
            m0 = rA0 * rB2;
            rC0_2 += m0;
            m0 = rA0 * rB3;
            rC0_3 += m0;
            m0 = rA0 * rB4;
            rC0_4 += m0;
            pA0 += incAk0;
            pB0 += incBk0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_cJIK0x0x24TN1x1x1_a1_bX(M, k, 24, alpha, ca, lda, cb + (((Nb) << 4)+((Nb) << 3)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_cJIK0x0x24TN24x24x0_a1_bX
   (const int M, const int N, const int K, const float alpha, const float * ATL_RESTRICT A, const int lda, const float * ATL_RESTRICT B, const int ldb, const float beta, float * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=T, TB=N, MB=0, NB=0, KB=24, 
 * lda=24, ldb=24, ldc=0, mu=4, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.3)
 */
{
   const int Mb = (M>>2)<<2;
   const int Nb = (N/5)*5;
   const float *ca=A, *cb=B;
   float *cc=C;
   const float *stM = A + (((Mb) << 4)+((Mb) << 3));
   const float *stN = B + (((Nb) << 4)+((Nb) << 3));
   const float *pfA = stM;
   const int incPFA0 = (((int)(stM - A))*4*5)/(M*N*sizeof(float));
   const int incPFA = (1 > incPFA0) ? 1 : incPFA0;
   #define incAk 1
   const int incAm = 72, incAn = -(((Mb) << 4)+((Mb) << 3));
   #define incBk 1
   const int incBm = -24, incBn = 120;
   #define incAk0 incAk
   #define incBk0 incBk
   #define incCm 8
   const int incCn = (((ldc) << 3)+((ldc) << 1)) - (((Mb) << 1));
   float *pC0=C, *pC1=pC0+(((ldc) << 1)), *pC2=pC1+(((ldc) << 1)), *pC3=pC2+(((ldc) << 1)), *pC4=pC3+(((ldc) << 1));
   const float *pA0=A;
   const float *pB0=B;
   register int k;
   register float rA0, rA1, rA2, rA3;
   register float rB0, rB1, rB2, rB3, rB4;
   register float m0;
   register float rC0_0, rC1_0, rC2_0, rC3_0, rC0_1, rC1_1, rC2_1, rC3_1, rC0_2, rC1_2, rC2_2, rC3_2, rC0_3, rC1_3, rC2_3, rC3_3, rC0_4, rC1_4, rC2_4, rC3_4;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            do /* M-loop */
            {
               ATL_pfl1R(pfA);
               pfA += incPFA;
               rA0 = beta;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[2];
               rC1_0 *= rA0;
               rC2_0 = pC0[4];
               rC2_0 *= rA0;
               rC3_0 = pC0[6];
               rC3_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[2];
               rC1_1 *= rA0;
               rC2_1 = pC1[4];
               rC2_1 *= rA0;
               rC3_1 = pC1[6];
               rC3_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[2];
               rC1_2 *= rA0;
               rC2_2 = pC2[4];
               rC2_2 *= rA0;
               rC3_2 = pC2[6];
               rC3_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[2];
               rC1_3 *= rA0;
               rC2_3 = pC3[4];
               rC2_3 *= rA0;
               rC3_3 = pC3[6];
               rC3_3 *= rA0;
               rC0_4 = *pC4;
               rC0_4 *= rA0;
               rC1_4 = pC4[2];
               rC1_4 *= rA0;
               rC2_4 = pC4[4];
               rC2_4 *= rA0;
               rC3_4 = pC4[6];
               rC3_4 *= rA0;
/*
 *             Start pipeline
 */
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[24];
               m0 = rA0 * rB0;
               rA2 = pA0[48];

               for (k=23; k; k--) /* easy loop to unroll */
               {
                  rC0_0 += m0;
                  m0 = rA1 * rB0;
                  rA3 = pA0[72];
                  rC1_0 += m0;
                  m0 = rA2 * rB0;
                  rB1 = pB0[24];
                  rC2_0 += m0;
                  m0 = rA3 * rB0;
                  rB2 = pB0[48];
                  rC3_0 += m0;
                  m0 = rA0 * rB1;
                  rB3 = pB0[72];
                  rC0_1 += m0;
                  m0 = rA1 * rB1;
                  rB4 = pB0[96];
                  rC1_1 += m0;
                  m0 = rA2 * rB1;
                  rC2_1 += m0;
                  m0 = rA3 * rB1;
                  rC3_1 += m0;
                  m0 = rA0 * rB2;
                  rC0_2 += m0;
                  m0 = rA1 * rB2;
                  rC1_2 += m0;
                  m0 = rA2 * rB2;
                  rC2_2 += m0;
                  m0 = rA3 * rB2;
                  rC3_2 += m0;
                  m0 = rA0 * rB3;
                  rC0_3 += m0;
                  m0 = rA1 * rB3;
                  rC1_3 += m0;
                  m0 = rA2 * rB3;
                  rC2_3 += m0;
                  m0 = rA3 * rB3;
                  rC3_3 += m0;
                  m0 = rA0 * rB4;
                  rC0_4 += m0;
                  m0 = rA1 * rB4;
                  rC1_4 += m0;
                  m0 = rA2 * rB4;
                  rC2_4 += m0;
                  m0 = rA3 * rB4;
                  rA0 = pA0[1];
                  rB0 = pB0[1];
                  rA1 = pA0[25];
                  rA2 = pA0[49];
                  rC3_4 += m0;
                  m0 = rA0 * rB0;
                  rA3 = pA0[73];
                  pA0 += incAk;
                  pB0 += incBk;
               } /* end K-loop */
/*
 *             Drain pipe on last iteration of K-loop
 */
               rC0_0 += m0;
               m0 = rA1 * rB0;
               rB1 = pB0[24];
               rC1_0 += m0;
               m0 = rA2 * rB0;
               rB2 = pB0[48];
               rC2_0 += m0;
               m0 = rA3 * rB0;
               rB3 = pB0[72];
               rC3_0 += m0;
               m0 = rA0 * rB1;
               rB4 = pB0[96];
               rC0_1 += m0;
               m0 = rA1 * rB1;
               rC1_1 += m0;
               m0 = rA2 * rB1;
               rC2_1 += m0;
               m0 = rA3 * rB1;
               rC3_1 += m0;
               m0 = rA0 * rB2;
               rC0_2 += m0;
               m0 = rA1 * rB2;
               rC1_2 += m0;
               m0 = rA2 * rB2;
               rC2_2 += m0;
               m0 = rA3 * rB2;
               rC3_2 += m0;
               m0 = rA0 * rB3;
               rC0_3 += m0;
               m0 = rA1 * rB3;
               rC1_3 += m0;
               m0 = rA2 * rB3;
               rC2_3 += m0;
               m0 = rA3 * rB3;
               rC3_3 += m0;
               m0 = rA0 * rB4;
               rC0_4 += m0;
               m0 = rA1 * rB4;
               rC1_4 += m0;
               m0 = rA2 * rB4;
               rC2_4 += m0;
               m0 = rA3 * rB4;
               rC3_4 += m0;
               pA0 += incAk0;
               pB0 += incBk0;
               *pC0 = rC0_0;
               pC0[2] = rC1_0;
               pC0[4] = rC2_0;
               pC0[6] = rC3_0;
               *pC1 = rC0_1;
               pC1[2] = rC1_1;
               pC1[4] = rC2_1;
               pC1[6] = rC3_1;
               *pC2 = rC0_2;
               pC2[2] = rC1_2;
               pC2[4] = rC2_2;
               pC2[6] = rC3_2;
               *pC3 = rC0_3;
               pC3[2] = rC1_3;
               pC3[4] = rC2_3;
               pC3[6] = rC3_3;
               *pC4 = rC0_4;
               pC4[2] = rC1_4;
               pC4[4] = rC2_4;
               pC4[6] = rC3_4;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pC4 += incCm;
               pA0 += incAm;
               pB0 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pC4 += incCn;
            pA0 += incAn;
            pB0 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_cJIK0x0x24TN4x1x1_a1_bX(M, k, 24, alpha, ca, lda, cb + (((Nb) << 4)+((Nb) << 3)), ldb, beta, cc + (((Nb*ldc) << 1)), ldc);
   if (Nb && (k=M-Mb))
      ATL_cJIK0x0x24TN1x5x1_a1_bX(k, Nb, 24, alpha, ca + (((Mb) << 4)+((Mb) << 3)), lda, cb, ldb, beta, cc + (((Mb) << 1)), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
